//***********************************************
//******************G_Code.c*********************
//***********************************************
//
//
//***********************************************
//******************G_Code.c*********************
//***********************************************

#include "G_Code.h"

//Glaobal variables
int F_Code=0; //copy of code numbers that are being worked on
int G_Code;
int M_Code;
int Inch_mm = 0;

float GX; //copy of Axis data being worked on
float GY;
float GZ;
float GI_Val;
float GJ_Val;
float GP_Val;

int GX_On =0;
int GY_On =0;
int GZ_On =0;
int GI_On =0;
int GJ_On =0;

//TODO here:
//Code in some data validation checks
//const char LetterCode[18]={"DFGHIJKLMNPQRSTXYZ"};
//const int GNumberCode[39]={
//0,1,2,3,4,10,17,18,19,20,
//21,40,41,42,43,49,53,45,55,56,
//57,58,59,80,81,82,83,84,85,86,
//87,88,89,90,91,92,93,94,98
//};
//const int MNumberCode[]={
//0,1,2,3,4,5,6,7,8,9,26,27,30,48,49,60};
/********************************************************/
//int Valid_G_Code (int Num)	{

//return 0;
//}
// Returns 0 if successful, otherwise returns 1
/********************************************************/

void G_CodeRun(char GC_L, int iGC_N, char GC_1L, float fGC_1, char GC_2L,
	         float fGC_2, char GC_3L, float fGC_3, char GC_4L,float fGC_4) {

//Going into this function we do not know where the axis data
//appears in the line. The following sorts axis Data and stores
//in local globals. It then issues function calls to run the code

	GX=0;
	if (GC_1L==0x58) GX=fGC_1;
	if (GC_2L==0x58) GX=fGC_2;
	if (GC_3L==0x58) GX=fGC_3;
	if (GC_4L==0x58) GX=fGC_4;
	if ((GC_1L==0x58)|(GC_2L==0x58)|(GC_3L==0x58)|(GC_4L==0x58)) {
		GX_On=1;
	}
	else
		GX_On=0;
	GY=0;
	if (GC_1L==0x59) GY=fGC_1;
	if (GC_2L==0x59) GY=fGC_2;
	if (GC_3L==0x59) GY=fGC_3;
	if (GC_4L==0x59) GY=fGC_4;
	if ((GC_1L==0x59)|(GC_2L==0x59)|(GC_3L==0x59)|(GC_4L==0x59)) {
		GY_On=1;
	}
	else
		GY_On=0;
	GZ=0;
	if (GC_1L==0x5A) GZ=fGC_1;
	if (GC_2L==0x5A) GZ=fGC_2;
	if (GC_3L==0x5A) GZ=fGC_3;
	if (GC_4L==0x5A) GZ=fGC_4;
	if ((GC_1L==0x5A)|(GC_2L==0x5A)|(GC_3L==0x5A)|(GC_4L==0x5A)) {
		GZ_On=1;
	}
	else
		GZ_On=0;
	GI_Val=0;
	if (GC_1L==0x49) GI_Val=fGC_1;
	if (GC_2L==0x49) GI_Val=fGC_2;
	if (GC_3L==0x49) GI_Val=fGC_3;
	if (GC_4L==0x49) GI_Val=fGC_4;
	if ((GC_1L==0x49)|(GC_2L==0x49)|(GC_3L==0x49)|(GC_4L==0x49)) {
		GI_On=1;
	}
	else
		GI_On=0;
	GJ_Val=0;
	if (GC_1L==0x4A) GJ_Val=fGC_1;
	if (GC_2L==0x4A) GJ_Val=fGC_2;
	if (GC_3L==0x4A) GJ_Val=fGC_3;
	if (GC_4L==0x4A) GJ_Val=fGC_4;
	if ((GC_1L==0x4A)|(GC_2L==0x4A)|(GC_3L==0x4A)|(GC_4L==0x4A)) {
		GJ_On=1;
	}
	else
		GJ_On=0;

	GP_Val=0;
	if (GC_1L==0x50) GP_Val=fGC_1;

	if (GC_1L==0x46) F_Code=fGC_1;	//sets the F code
	if (GC_2L==0x46) F_Code=fGC_2;
	if (GC_3L==0x46) F_Code=fGC_3;
	if (GC_4L==0x46) F_Code=fGC_4;


	setLCDC(0x40);      // set the cursor Line2
	switch(GC_L){
		case 0x47:  //G Code
			G_Code=iGC_N;
			if (G_Code==20)	Inch_mm=20; //Set Units Inches
			if (G_Code==21)	Inch_mm=21; //Set Units Metric
			if (G_Code==0) 	G_Code_G0();
			if (G_Code==1)	G_Code_G1();
			if (G_Code==2)	G_Code_G2();
			if (G_Code==3)	G_Code_G3();
			if (G_Code==4)	G_Code_G4();
			if (G_Code==10) G_Code_G10();
			break;
		case 0x4D:	//M Code
			M_Code=iGC_N;	//Sets M code
			G_Code=0, F_Code=0;
		//	if (M_Code==0)	; M5 Stop spindle
		//	if (M_Code==)	;
		//	if (M_Code==6)	; M6 Tool Change
		//	if (M_Code==3)	; M3 Start Spindle
			//putsLCD("M Code");
			break;
		default:
			setLCDC(0x40); 
			//putsLCD("Invalid Code");
	}//Switch

}
/********************************************************/
//    G Code Functions to be added here.
//    Please use same format and annotate.
/********************************************************/
void G_Code_G0(void)	{ //G00	rapid positioning 
//Tool coordinates are set as Globals.
// Sets variables and calls functions to execute the code

	if (M_Code == 0) M_Code = StopSpindle; 	//if not set, make default
	if (F_Code == 0) F_Code = FastFeed; 	//if not set, make default
	
	//Load values into Stepper control
	Stepper_LoadNewValues(F_Code, M_Code);
	Stepper_CalcStepsLine(Inch_mm);
	Stepper_InitIO(); //Init port A and the pulse delay timer
	Stepper_Run3DLine(); 
	Stepper_SaveValues();
	
}
/********************************************************/
void G_Code_G1(void)	{ //G01	linear interpolation
//Tool coordinates are set as Globals.
//Sets variables and calls functions to execute the code

	if (M_Code == 0) M_Code = StopSpindle; 	//if not set, make default
	if (F_Code == 0) F_Code = SlowFeed; 	//if not set, make slowest feed rate
	
	//Load values into Stepper control
	Stepper_LoadNewValues(F_Code, M_Code);
	Stepper_CalcStepsLine(Inch_mm);
	Stepper_InitIO();//Init port A and the pulse delay timer
	Stepper_Run3DLine(); //Linear machineing
	Stepper_SaveValues();

}
/********************************************************/
void G_Code_G2(void)	{ //G02	circular interpolation (clockwise)  
//The tool is already at the start position for this instruction
// X,Y coordinates following G2 are the end position of the tool.
// I	X-axis offset to centre
// J	Y-axis offset to centre

	if (M_Code == 0) M_Code = StopSpindle; 	//if not set, make default
	if (F_Code == 0) F_Code = SlowFeed; 	//if not set, make slowest feed rate

	Stepper_LoadNewValues(F_Code, M_Code);
	Stepper_InitIO();//Init port A and the pulse delay timer
	Stepper_CalcStepsArc(Inch_mm);
	Stepper_RunArcLine(2); //run as G2
	Stepper_SaveValues();

}
/********************************************************/
void G_Code_G3(void)	{ //G03	circular interpolation (c-clockwise)  
//The tool is already at the start position for this instruction
// X,Y coordinates following G3 are the end position of the tool.
// I	X-axis offset to centre
// J	Y-axis offset to centre

	if (M_Code == 0) M_Code = StopSpindle; 	//if not set, make default
	if (F_Code == 0) F_Code = SlowFeed; 	//if not set, make slowest feed rate

	Stepper_LoadNewValues(F_Code, M_Code);
	Stepper_InitIO();//Init port A and the pulse delay timer
	Stepper_CalcStepsArc(Inch_mm);
	Stepper_RunArcLine(3); //run as G3
	Stepper_SaveValues();
}
/********************************************************/
void G_Code_G4(void)	{ //G4 Dwell time
//P   Dwell time in seconds
int delay = 0;

//TODO HERE: Time needs sorting out, values here are incorrect

	if (GP_Val != 0)	{
		delay = (int)GP_Val*1000;
		delay /= 250;
		if (delay ==0)(delay=1);//min value
		do	{	
			Delayms(25);
			delay--;
		}while (delay !=0);
	}

}
/********************************************************/

/********************************************************/
void G_Code_G10(void)	{ //G10 Coordinate system origin


}
/********************************************************/
